#ifndef AMT_LOCKER
#define AMT_LOCKER

#include <amt/Defines.h>

namespace AMT
{

namespace Locker
{

template <class T_>
struct SimpleLocker
{
	static void lock(T_ &obj) { obj.locker().lock(); }
	static void unlock(T_ &obj) { obj.locker().unlock(); }
};

template <class Obj_>
class ManipBase
{
	ManipBase &operator = (const ManipBase &);
protected:
	Obj_ &m_obj;
	ManipBase(Obj_ &o) : m_obj(o) { o.locker().lock(); }
	~ManipBase()
	{ m_obj.locker().unlock(); }
	ManipBase(const ManipBase &m) : m_obj(m.m_obj)
	{ m_obj.locker().lock(); }
};

}

}

#endif
