#ifndef AMT_TYPES_H_
#define AMT_TYPES_H_

#include <stddef.h>
#ifndef _WIN32
#include <stdint.h>
#endif

namespace AMT
{

namespace Integers
{
#ifdef _WIN32
typedef signed __int8 S8;
typedef signed __int16 S16;
typedef signed __int32 S32;
typedef signed __int64 S64;
typedef unsigned __int8 U8;
typedef unsigned __int16 U16;
typedef unsigned __int32 U32;
typedef unsigned __int64 U64;
#else
typedef int8_t S8;
typedef int16_t S16;
typedef int32_t S32;
typedef int64_t S64;
typedef uint8_t U8;
typedef uint16_t U16;
typedef uint32_t U32;
typedef uint64_t U64;
#endif
}
using namespace Integers;

typedef U32 Serial;
typedef size_t Size;

}

#endif
