#include <amt/Mutex.h>

using namespace AMT::Locker;

#ifdef AMT_MT
struct Bits_::MutexMDOpsImpl : public MutexMDOps
{
	pthread_mutexattr_t m_attr;
public:
	MutexMDOpsImpl()
	{
		if (pthread_mutexattr_init(&m_attr))
			abort();
		if (pthread_mutexattr_settype(&m_attr,
					      PTHREAD_MUTEX_RECURSIVE))
			abort();
	}
	~MutexMDOpsImpl()
	{
	}
	void init(Bits_::MutexMD &md) const
	{
		pthread_mutex_init(&md.m_mutex, &m_attr);
	}
	void uninit(Bits_::MutexMD &md) const
	{
		pthread_mutex_uninit(&md.m_mutex);
	}
	void lock(Bits_::MutexMD &md) const
	{
		pthread_mutex_lock(&md.m_mutex);
	}
	void unlock(Bits_::MutexMD &md) const
	{
		pthread_mutex_unlock(&md.m_mutex);
	}
	bool trylock(Bits_::MutexMD &md) const
	{
		return pthread_mutex_trylock(&md.m_mutex) == 0;
	}
};
namespace
{
const Bits_::MutexMDOpsImpl impl;
}
const Bits_::MutexMDOps * const Bits_::MutexMD::s_ops = &impl;
#else
const Bits_::MutexMDOps * const Bits_::MutexMD::s_ops = NULL;
#endif
